/////////////////////////////////////////////////////////////////////////////////
//
// countptr.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: b2mailstream.h,v $
 * Revision 1.2  2001/01/20 07:40:17  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.1  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */

#pragma once
#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4290)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////////
//
#include <string>
#include <sstream>
#include "B2APIEx.h"


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;


/////////////////////////////////////////////////////////////////////////////////
//
template<class _E,
    class _Tr = char_traits<_E>,
    class _A = allocator<_E> >
    class basic_b2mailbuf : public basic_stringbuf<_E, _Tr, _A> {
public:
    typedef basic_stringbuf<_E, _Tr, _A> _Super;
    typedef basic_string<_E, _Tr, _A> _Mystr;
    explicit basic_b2mailbuf(
            ios_base::openmode _W = ios_base::in | ios_base::out)
            : _Super(_W)
            {_InitAPI(); }
    /**Composep*/
    explicit basic_b2mailbuf(HWND _InitWnd,
            ios_base::openmode _W = ios_base::in | ios_base::out)
            : _Super(_W)
            {try
                {_InitAPI();
                _Init(_InitWnd, _W); }
            catch (runtime_error& _err)
                { }}
    /**ComposepA\[Xi[*/
    basic_b2mailbuf(HWND _InitWnd,
            _Mystr _InitS,
            ios_base::openmode _W = ios_base::in | ios_base::out)
            : _Super(_W)
            {_InitAPI();
            str(_InitS);
            _Wnd = _InitWnd;
            _Belong = _Compose; }
    /**Mail viewp*/
    basic_b2mailbuf(_Mystr _InitMid,
            ios_base::openmode _W = ios_base::in | ios_base::out)
            : _Super(_W)
            {try
                {_InitAPI();
                _Init(_InitMid, _W); }
            catch (runtime_error& _err)
                { }} 
    /**Mail viewpA\[Xi[*/
    explicit basic_b2mailbuf(_Mystr _InitMid,
            _Mystr _InitS,
            ios_base::openmode _W = ios_base::in | ios_base::out)
            : _Super(_W)
            {_InitAPI();
            str(_InitS);
            _Mid = _InitMid;
            _Belong = _MailView; }
    virtual ~basic_b2mailbuf()
            {}
protected:
        virtual int sync()
        {if (_Belong == _Compose)
            _B2->CompSetSource(_Wnd, str().c_str());
        else
            _B2->SetSource(_Mid.c_str(), str().c_str());
        return 0; }
    void _InitAPI()
        {_B2 = B2APIEx::InstanceEx(); }
    void _Init(HWND _InitWnd, ios_base::open_mode _W)
        throw(runtime_error)
        {_Wnd = _InitWnd;
        _Belong = _Compose;
        if (_W & ios_base::in)
            {try
                {_Mystr _S = _GetSource();
                str(_S); }
            catch (logic_error& _err)
                { }}}
    void _Init(const _Mystr& _InitMid, ios_base::open_mode _W)
        throw(runtime_error)
        {_Mid = _InitMid;
        _Belong = _MailView;
        if (_W & ios_base::in) 
            {try
                {_Mystr _S = _GetSource();
                str(_S); }
            catch (logic_error& _err)
                { }}}
    _Mystr _GetSource()
        throw(logic_error, runtime_error)
        {if (_Belong == _None)
            throw logic_error("Not attached to B2");
        _Mystr _S;
		try
			{_S = (_Belong == _Compose) ?
            _B2->CompGetSource(_Wnd) : _B2->GetSource(_Mid.c_str()); }
        catch (...)
			{throw runtime_error("B2 inner error"); }
        return _S; }
private:
    enum _BelongState {_None = 0, _Compose = 1, _MailView = 2 };
    B2APIEx* _B2;
    HWND _Wnd;
    _Mystr _Mid;
    _BelongState _Belong;
    };


/////////////////////////////////////////////////////////////////////////////////
//
template<class _E,
    class _Tr = char_traits<_E> >
    class basic_b2mailstream : public basic_iostream<_E, _Tr> {
public:
    typedef basic_string<_E, _Tr> _Mystr;
    typedef basic_b2mailbuf<_E, _Tr> _Buffer;
    typedef basic_ios<_E, _Tr> _Hyper;
    typedef basic_iostream<_E, _Tr> _Super;
    /**Composep*/
    explicit basic_b2mailstream(HWND _Wnd, openmode _W = in | out)
        : _Hyper(), _Super(0), _Sb(_Wnd, _W)
        { this->init(&_Sb); }
    /**ComposepA\[Xi[*/
    explicit basic_b2mailstream(HWND _Wnd, _Mystr _InitS, openmode _W = in | out)
        : _Hyper(), _Super(0), _Sb(_Wnd, _InitS, _W)
        { this->init(&_Sb); }
    /**Mail viewp*/
    explicit basic_b2mailstream(_Mystr _Mid, openmode _W = in | out)
        : _Hyper(), _Super(0), _Sb(_Mid, _W)
        { this->init(&_Sb); }
    /**Mail viewpA\[Xi[*/
    explicit basic_b2mailstream(_Mystr _Mid, _Mystr _InitS, openmode _W = in | out)
        : _Hyper(), _Super(0), _Sb(_Mid, _InitS, _W)
        { this->init(&_Sb); }
    virtual ~basic_b2mailstream()
        {}
    _Buffer *rdbuf() const
        {return ((_Buffer *)&_Sb); }
    _Mystr str() const
        {return (_Sb.str()); }
    void str(const _Mystr& _S)
        {_Sb.str(_S); }
private:
    _Buffer _Sb;
    };


/////////////////////////////////////////////////////////////////////////////////
//
typedef basic_b2mailbuf<char> b2mailbuf;
typedef basic_b2mailstream<char> b2mailstream;


