/////////////////////////////////////////////////////////////////////////////////
//
// PGPlog.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//


#pragma once


/////////////////////////////////////////////////////////////////////////////////
//
#include <windows.h>
#include <ddeml.h>
#include <string>
#include "CriticalSection.h"


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;


/////////////////////////////////////////////////////////////////////////////////
//
class PGPlog
{
public:
    static PGPlog* Instance();

    virtual ~PGPlog();
    virtual void Release();
    virtual bool setLogMessage(HWND hwnd, char *mes);//const string& mes);

protected:
    PGPlog();
    BOOL  (* SendPGPlogMsg) (HWND hwnd, char* szMsg);


private:
    HINSTANCE pgpsc_instance;
    static PGPlog* instance;
    static long counter;
    static CriticalSection critsec;
};


