/////////////////////////////////////////////////////////////////////////////////
//
// PgpMail.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: PgpMail.cpp,v $
 * Revision 1.3  2001/01/20 07:40:15  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.2  2000/11/29 12:46:34  syou
 * - broken version line ̏CBsɂ܂Ă͖̂炩Ƀ~X
 *   łB
 *
 * Revision 1.1  2000/11/07 15:57:18  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////////
//
#include "PgpMail.h"


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;


/////////////////////////////////////////////////////////////////////////////////
//
PgpMail::PgpMail() : BkMail()
{
}


/**
 * Destructer
 * ɉȂ
 */
PgpMail::~PgpMail()
{
}


string PgpMail::getPgpOriginalText(HWND hWnd, bool pgpmime)
{
    if (!pgpmime) {
        return text;
    }

    BkMail temp;

    try {
        if (encodeQuotedPrintable()) {
            ::SendMessage(hWnd, WM_SET_TRANSFER_SAFE, (WPARAM)TRUE, 0);
            string source = B2APIEx::InstanceEx()->CompGetSource(hWnd);
            temp.fromString(source);
        }
        else {
            temp.fromString(toString());
        }
        string type = temp.getHeader("Content-Type");
        string encoding = temp.getHeader("Content-Transfer-Encoding");
        temp.clearHeader();
        temp.setHeader("Content-Type", type);
        temp.setHeader("Content-Transfer-Encoding", encoding);
    }
    catch (exception& e) {
        const char* mes = e.what();
    }

    return temp.toString();
}


bool PgpMail::encodeQuotedPrintable()
{
    bool result = false;
    BkMailList::iterator first = findMimeItem("", "", FINDMIMEITEM_DEFAULT);
    BkMailList::iterator last = end();
    for (; first != last; ++first) {
        string encoding = (*first)->getHeader("Content-Transfer-Encoding");
        if (strnicmp(encoding.c_str(), "8bit", 4) == 0 || strnicmp(encoding.c_str(), "binary", 6) == 0) {
            result = true;
        }
    }
    return result;
}


/**
 * Ώۃ[charsetISO-2022-JṔAsCP932gpĂƂA
 * eLXgShift_JISłƂāAISO-2022-JPɕϊ
 */
void PgpMail::setTextWithJpnProc(const string& newText, const string& newCharset)
{
    if (((!newCharset.empty()) && stricmp(newCharset.c_str(), "ISO-2022-JP") == 0) ||
          (newCharset.empty()  && ::GetACP() == 932)) {
        B2API* b2api = B2APIEx::Instance();
        LPSTR temp = b2api->ISO_2022_JP(newText.c_str(), TRUE);
        text.assign(temp);
        charset.assign(newCharset);
        b2api->Free(temp);
    } else {
        text.assign(newText);
        charset.assign(newCharset);
    }
}


/**
 * Ώۃ[charsetISO-2022-JP̂ƂAISO-2022-JPȃeLXg
 * Shift_JISɒu
 */
string PgpMail::getTextWithJpnProc()
{
    if ((!charset.empty()) && stricmp(charset.c_str(), "ISO-2022-JP") == 0) {
        B2API* b2api = B2APIEx::Instance();
        LPSTR temp = b2api->ISO_2022_JP(text.c_str(), FALSE);
        string out(temp);
        b2api->Free(temp);
        return out;
    }
    return text;
}


void PgpMail::setText(const string& newText)
{
    text = newText;
}


string PgpMail::getText()
{
    return text;
}


/////////////////////////////////////////////////////////////////////////////////
//
#pragma warning(pop)